--- scripts/chdist.pl.orig	2010-03-04 13:52:07.212133847 +0900
+++ scripts/chdist.pl	2010-03-04 19:19:13.820129323 +0900
@@ -311,7 +311,8 @@
     mkdir($datadir);
   }
   mkdir($dir);
-  foreach $d (('/etc/apt', '/var/lib/apt/lists/partial', '/var/lib/dpkg', '/var/cache/apt/archives/partial')) {
+  foreach $d (('/etc/apt', '/etc/apt/apt.conf.d', '/etc/apt/preferences.d/', 
+               '/var/lib/apt/lists/partial', '/var/lib/dpkg', '/var/cache/apt/archives/partial')) {
      recurs_mkdir("$dir/$d");
   }
 
@@ -330,13 +331,22 @@
      }
      # Fill in sources.list with example contents
      print FH <<EOF;
+#deb http://ftp.debian.org/debian/ stable main contrib non-free
+#deb-src http://ftp.debian.org/debian/ stable main contrib non-free
+
+#deb http://ftp.debian.org/debian/ testing main contrib non-free
+#deb-src http://ftp.debian.org/debian/ testing main contrib non-free
+
 #deb http://ftp.debian.org/debian/ unstable main contrib non-free
 #deb-src http://ftp.debian.org/debian/ unstable main contrib non-free
 
-#deb http://archive.ubuntu.com/ubuntu dapper main restricted
-#deb http://archive.ubuntu.com/ubuntu dapper universe multiverse
-#deb-src http://archive.ubuntu.com/ubuntu dapper main restricted
-#deb-src http://archive.ubuntu.com/ubuntu dapper universe multiverse
+#deb http://ftp.debian.org/debian/ experimental main contrib non-free
+#deb-src http://ftp.debian.org/debian/ experimental main contrib non-free
+
+#deb http://archive.ubuntu.com/ubuntu lucid main restricted
+#deb http://archive.ubuntu.com/ubuntu lucid universe multiverse
+#deb-src http://archive.ubuntu.com/ubuntu lucid main restricted
+#deb-src http://archive.ubuntu.com/ubuntu lucid universe multiverse
 EOF
   }
   close FH;
@@ -350,12 +360,19 @@
   print FH <<EOF;
 Apt {
    Architecture "$arch";
+   GPGV::TrustedKeyring "$dir/etc/apt/trusted.gpg"
 }
 
 Dir "$dir";
 Dir::State::status "$dir/var/lib/dpkg/status";
 EOF
   close FH;
+  foreach $gpg_system_trusted (('debian-archive-keyring.gpg', 'debian-archive-removed-keys.gpg', 
+                                'ubuntu-archive-keyring.gpg', 'ubuntu-archive-removed-keys.gpg')) {
+     if (-f "/usr/share/keyrings/$gpg_system_trusted") {
+       system("cat /usr/share/keyrings/$gpg_system_trusted >> $dir/etc/apt/trusted.gpg");
+     }
+  }
   print "Now edit $dir/etc/apt/sources.list\n";
   print "Then run chdist apt-get $dist update\n";
   print "And enjoy.\n";
